package cn.superdesk.uniorder.dubbo.facade.invoice.common;


import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.common.InvoiceType;
import cn.superdesk.uniorder.dto.param.invoice.common.InvoiceTypeCacheCriteria;
import cn.superdesk.uniorder.dto.param.invoice.common.InvoiceTypeOpCriteria;
import cn.superdesk.uniorder.dto.param.invoice.common.InvoiceTypeParam;
import cn.superdesk.uniorder.dto.param.invoice.common.InvoiceTypeQueryCriteria;
import cn.superdesk.uniorder.dto.vo.invoice.common.InvoiceTypeOpInvoiceSettingLoadingVo;
import cn.superdesk.uniorder.dto.vo.invoice.common.InvoiceTypePageQueryVo;
import cn.superdesk.uniorder.dto.vo.invoice.common.InvoiceTypeSelectVo;
import com.github.pagehelper.PageInfo;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-07-23 15:30:45
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-07-23 15:30:45
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface DubboInvoiceTypeService {

	/****************************************** extends BaseService 部分 start ******************************************/

	@Deprecated
	void addObj(InvoiceTypeParam param);

	@Deprecated
	void updateObj(InvoiceTypeParam param);

	@Deprecated
	void deleteObj(Long id);

	@Deprecated
	InvoiceType findById(Long id);

	@Deprecated
	PageInfo<InvoiceType> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize);

	@Deprecated
	List<InvoiceType> findAll(Map<String, Object> queryMap);

	/****************************************** extends BaseService 部分   end ******************************************/


	void addInvoiceType(InvoiceTypeParam param);

	void updateInvoiceType(InvoiceTypeParam param);

	void deleteInvoiceType(Long id);

	InvoiceType findInvoiceTypeById(Long id);

	R<List<InvoiceType>> pageQuery(InvoiceTypeQueryCriteria queryCriteria, LoginSysUser loginSysUser);

	R<List<InvoiceTypePageQueryVo>> pageQuerySugarUp(InvoiceTypeQueryCriteria queryCriteria, LoginSysUser loginSysUser);

	List<InvoiceTypeSelectVo> selectQuery(InvoiceTypeQueryCriteria queryCriteria, LoginSysUser loginSysUser);


	/****************************************** 操作部分 start ******************************************/




	int opSetDefault(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);

	int opSetNormal(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);

	int opSetEnable(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);

	int opSetDisable(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);


	/****************************************** 操作部分   end ******************************************/


	/****************************************** 操作类 进阶 模块X发票种类-开票方式 start ******************************************/

	int opInvoiceSettingSetDefault(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);

	int opInvoiceSettingSetNormal(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);

	int opInvoiceSettingSetEnable(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);

	int opInvoiceSettingSetDisable(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);

	InvoiceTypeOpInvoiceSettingLoadingVo opInvoiceSettingLoading(InvoiceTypeOpCriteria opCriteria, LoginSysUser loginSysUser);

	/****************************************** 操作类 进阶 模块X发票种类-开票方式   end ******************************************/





	/****************************************** 缓存 start ******************************************/

	void cacheInit(InvoiceTypeCacheCriteria criteria);

	void cacheRefresh(InvoiceTypeCacheCriteria criteria);

	void cacheRemove(InvoiceTypeCacheCriteria criteria);

	String cacheGet(InvoiceTypeCacheCriteria criteria);
}
